unit ExeMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    WndProc: TWndMethod;
    procedure CustomWndProc(var Msg: TMessage);
    procedure HookedCBTProc(const Msg: TMessage);
    procedure HookedMouseProc(const Msg: TMessage);
    procedure MessageOut(const AMsg: String);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    ExeInfo;

const
    HOOK_DLL_NAME = 'PasteItHook.dll';

//-----------------------------------------------------------------------------
//  DLLC|[gEăX^eBbNN
function HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure  HookUnInstall(); stdcall;external HOOK_DLL_NAME;

//-----------------------------------------------------------------------------
//  NX擾
//  Win32 API by Object Pascal of Delphi
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetClassNameStr(const hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;

//-----------------------------------------------------------------------------
//  EBhE̍ŏĩEBhE擾
//  Win32 API by Object Pascal of Delphi
function GetMostTopLevelWindow(const hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

//-----------------------------------------------------------------------------
//  bZ[W\
procedure TMainForm.MessageOut(const AMsg: String);
var
    NowStr: string;
begin
    NowStr := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
    Memo1.Lines.Add(NowStr + ' ' + AMsg);
end;

//-----------------------------------------------------------------------------
//  tH[RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  EBhEvV[WobNAbv
    WndProc := Self.WindowProc;
    //  ւ
    Self.WindowProc := CustomWndProc;
    //  tbNCXg[
    HookInstall(Self.Handle);
end;

//-----------------------------------------------------------------------------
//  tH[fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  Ô߃ACXg[
    HookUnInstall();
    //  Ô߃EBhEvV[W߂
    Self.WindowProc := WndProc;
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.Button1Click(Sender: TObject);
begin
    ShowInfoForm();
end;

//-----------------------------------------------------------------------------
//  ւpEBhEvV[W
procedure TMainForm.CustomWndProc(var Msg: TMessage);
begin
    //  DLL Ō߂ }EXtbNp̃bZ[W ID Ɣr
    if (Msg.Msg = WM_APP + 1) then
    begin
        HookedMouseProc(Msg);
    end;

    //  낤Ƃ͌ĂԁB
    WndProc(Msg);
end;

//-----------------------------------------------------------------------------
//  HookedCBTProc mF
procedure TMainForm.HookedCBTProc(const Msg: TMessage);
begin
{
    case Msg.Msg - WM_APP * 1 of
        HCBT_ACTIVATE:      MessageOut('HCBT_ACTIVATE', Msg);
        HCBT_CLICKSKIPPED:  MessageOut('HCBT_CLICKSKIPPED', Msg);
        HCBT_CREATEWND:     MessageOut('HCBT_CREATEWND', Msg);
        HCBT_DESTROYWND:    MessageOut('HCBT_DESTROYWND', Msg);
        HCBT_KEYSKIPPED:    MessageOut('HCBT_KEYSKIPPED', Msg);
        HCBT_MINMAX:        MessageOut('HCBT_MINMAX', Msg);
        HCBT_MOVESIZE:      MessageOut('HCBT_MOVESIZE', Msg);
        HCBT_QS:            MessageOut('HCBT_QS', Msg);
        HCBT_SETFOCUS:      MessageOut('HCBT_SETFOCUS', Msg);
        HCBT_SYSCOMMAND:    MessageOut('HCBT_SYSCOMMAND', Msg);
    end;
}
end;

//-----------------------------------------------------------------------------
//  HookedMouseProc mF
procedure TMainForm.HookedMouseProc(const Msg: TMessage);
var
    LPoint: TPoint;
    LHandle: HWND;
    LClassName: String;
begin
    //  _Ń}EX̐^ɂEBhE擾
    GetCursorPos(LPoint);
    LHandle := WindowFromPoint(LPoint);
    //  eq֌Ŵڂ
    LHandle := GetMostTopLevelWindow(LHandle);
    //  NX擾
    LClassName := UpperCase(GetClassNameStr(LHandle));
    //  fXNgbv?
    if (LClassName = 'PROGMAN') then
    begin
        case Msg.WParam of
            WM_MBUTTONDBLCLK: MessageOut('WM_MBUTTONDBLCLK');
            WM_LBUTTONDBLCLK: MessageOut('WM_LBUTTONDBLCLK');
        end;
    end;
end;
end.

